diff --git a/game/client/src/main/java/net/minecraft/client/render/Font.java b/game/client/src/main/java/net/minecraft/client/render/Font.java
index f6e52fb5d..45af56f0d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/Font.java
+++ b/game/client/src/main/java/net/minecraft/client/render/Font.java
@@ -23,7 +23,9 @@ import java.util.regex.Pattern;
 
 public class Font {
     private static final Pattern FORMATTING_CODE_REGEX = Pattern.compile("(?i)\\u00A7[0-9A-FK-OR]");
+    private static final int MONOSPACE_WIDTH = 10;
 
+    private final boolean monospace;
     private final GameSettings gameSettings;
     private final Minecraft mc;
     private final byte[] charWidth;
@@ -51,6 +53,10 @@ public class Font {
     private boolean strikethroughStyle;
 
     public Font(Minecraft minecraft, GameSettings gameSettings, TextureManager textureManager) {
+        this(minecraft, gameSettings, textureManager, false);
+    }
+
+    public Font(Minecraft minecraft, GameSettings gameSettings, TextureManager textureManager, boolean monospace) {
         this.mc = minecraft;
         this.gameSettings = gameSettings;
         this.charWidth = new byte[65536];
@@ -67,13 +73,19 @@ public class Font {
         this.underlineStyle = false;
         this.strikethroughStyle = false;
         this.textureManager = textureManager;
+        this.monospace = monospace;
 
-        try (InputStream glyphStream = mc.texturePackList.getResourceAsStream("/font/glyph_sizes.bin");
-             InputStream glyphStreamDefault = mc.texturePackList.getResourceAsStream("/font/glyph_sizes_default.bin")) {
-            glyphStream.read(this.glyphWidth);
-            glyphStreamDefault.read(this.charWidth);
-        } catch (IOException e) {
-            throw new RuntimeException(e);
+        if (monospace) {
+            Arrays.fill(this.glyphWidth, (byte) MONOSPACE_WIDTH);
+            Arrays.fill(this.charWidth, (byte) MONOSPACE_WIDTH);
+        } else {
+            try (InputStream glyphStream = mc.texturePackList.getResourceAsStream("/font/glyph_sizes.bin");
+                 InputStream glyphStreamDefault = mc.texturePackList.getResourceAsStream("/font/glyph_sizes_default.bin")) {
+                glyphStream.read(this.glyphWidth);
+                glyphStreamDefault.read(this.charWidth);
+            } catch (IOException e) {
+                throw new RuntimeException(e);
+            }
         }
 
         for (int i = 0; i < 32; ++i) {
@@ -95,7 +107,7 @@ public class Font {
 
     private float renderCharAtPos(int formatCode, char c, boolean italic) {
         float charWidth;
-        if (c == 32)
+        if (c == 32 && !this.monospace)
         {
             charWidth = 4.0F;
         }
@@ -117,10 +129,19 @@ public class Font {
 
     private boolean loadDefaultTexture(int id) {
         boolean success = true;
-        String fontPath = String.format("/font/font_%02X.png", id);
+
+        String fontPath;
+        if (this.monospace) {
+            fontPath = String.format("/font/mono_%02X.png", id);
+        } else {
+            fontPath = String.format("/font/font_%02X.png", id);
+        }
         String glyphPath = String.format("/font/glyph_%02X.png", id);
 
         Texture fontTexture = this.textureManager.loadTextureNoDefault(fontPath);
+        if (fontTexture == null && this.monospace) {
+            fontTexture = this.textureManager.loadTextureNoDefault(String.format("/font/font_%02X.png", id));
+        }
         if (fontTexture == null) {
             fontTexture = this.textureManager.loadTextureNoDefault(glyphPath);
         }
@@ -580,6 +601,9 @@ public class Font {
     }
 
     public int getCharWidth(char c) {
+        if (this.monospace) {
+            return MONOSPACE_WIDTH / 2 + 1;
+        }
         /*if (c == '§') {
             return -1;
         } else */if (c == ' ') {
@@ -697,7 +721,7 @@ public class Font {
         } else {
             String var4 = s.substring(0, var3);
             char var5 = s.charAt(var3);
-            boolean var6 = var5 == 32 || var5 == 10;
+            boolean var6 = (var5 == 32 && !this.monospace) || var5 == 10;
             String var7 = getFormatFromString(var4) + s.substring(var3 + (var6 ? 1 : 0));
             return var4 + "\n" + this.wrapFormattedStringToWidth(var7, maxWidth);
         }
@@ -716,7 +740,9 @@ public class Font {
                     --var5;
                     break;
                 case ' ':
-                    var6 = var5;
+                    if (!monospace) {
+                        var6 = var5;
+                    }
                 default:
                     var4 += this.getCharWidth(var8);
                     if(var7) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java b/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
index 671a831f6..a41faa6bf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
@@ -48,7 +48,7 @@ public class LightmapHelper {
 			
 			String path = "/assets/minecraft/textures/environment/lightmap" + dimension + ".png";
 
-            LOGGER.info("Loading custom lightmap '{}'", path);
+            LOGGER.info("Attempting to load custom lightmap '{}'", path);
 			customLightmap = mc.textureManager.getImage(path);
 			
 			if(customLightmap == Textures.missingTexture) {
@@ -58,7 +58,7 @@ public class LightmapHelper {
 			if(customLightmap != null) {
 				LOGGER.info("Loaded custom lightmap!");
 			}else {
-				LOGGER.info("No custom lightmap found");
+				LOGGER.warn("No custom lightmap found.");
 			}
 		}else {
 			customLightmap = null;
diff --git a/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java b/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
index 9450e1ac9..b42777ffd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
@@ -25,12 +25,15 @@ public class OpenGLHelper {
 	public static boolean gl31 = false;
 	
     public static void testCapabilities(Minecraft minecraft) {
+		LOGGER.info("");
+		LOGGER.info("=== GPU VENDOR INFO ===");
         LOGGER.info(glGetString(GL_VERSION));
         LOGGER.info(glGetString(GL_VENDOR));
         LOGGER.info(glGetString(GL_RENDERER));
-        
-        ContextCapabilities capabilities = GLContext.getCapabilities();
 
+		LOGGER.info("");
+
+        ContextCapabilities capabilities = GLContext.getCapabilities();
         LOGGER.info("GL_ARB_framebuffer_object: {}", capabilities.GL_ARB_framebuffer_object);
         LOGGER.info("GL_ARB_occlusion_query: {}", capabilities.GL_ARB_occlusion_query);
         LOGGER.info("GL_NV_fog_distance: {}", capabilities.GL_NV_fog_distance);
@@ -39,16 +42,19 @@ public class OpenGLHelper {
         enableSphericalFog = capabilities.GL_NV_fog_distance;
         gl20 = capabilities.OpenGL20;
         gl31 = capabilities.OpenGL31;
+
+		LOGGER.info("");
         
 		if(minecraft.gameSettings.disableShaders.value) {
 			Shaders.enableShaders = false;
-			LOGGER.info("Shaders disabled in options file!");
+			LOGGER.warn("Shaders disabled in options file!");
 			return;
 		}
 		
 		Shaders.enableShaders = capabilities.GL_ARB_framebuffer_object && capabilities.OpenGL20;
 
-        LOGGER.info("Enable Shaders: {}", Shaders.enableShaders);
+        LOGGER.info("Shaders enabled: {}", Shaders.enableShaders);
+		LOGGER.info("");
     }
 	
 	public static void checkError(String info) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
index d51333690..55c1347e1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
@@ -63,20 +63,29 @@ public class PostProcessingManager
         float surfaceness = adjustedY / hToQRange;
         surfaceness = MathHelper.clamp(surfaceness, 0.0f, 1.0f);
 
-        double temperature = mc.currentWorld.getBlockTemperature((int)mc.thePlayer.x, (int)mc.thePlayer.z); // Ranges from 0.0 to 1.0
-        if (temperature == Double.NEGATIVE_INFINITY) temperature = lastTemperature;
+        double t = mc.currentWorld.getBlockTemperature((int)mc.thePlayer.x, (int)mc.thePlayer.z); // Ranges from 0.0 to 1.0
+        if (t == Double.NEGATIVE_INFINITY) t = lastTemperature;
+        final double temperature = t;
         lastTemperature = temperature;
-        double humidity = mc.currentWorld.getBlockHumidity((int)mc.thePlayer.x, (int)mc.thePlayer.z); // Ranges from 0.0 to 1.0
-        if (humidity == Double.NEGATIVE_INFINITY) humidity = lastHumidity;
+        double h = mc.currentWorld.getBlockHumidity((int)mc.thePlayer.x, (int)mc.thePlayer.z); // Ranges from 0.0 to 1.0
+        if (h == Double.NEGATIVE_INFINITY) h = lastHumidity;
+        final double humidity = h;
         lastHumidity = humidity;
 
         // Perform base temperature change
         if (mc.currentWorld.dimension == Dimension.OVERWORLD)
         {
             lastTemperature = temperature;
-            temperature = (temperature * 2) - 1.0; // Ranges from -1.0 to 1.0
-            saturation += (float) (0.25 * temperature * surfaceness);
-            contrast += (float) (-0.1 * temperature * surfaceness);
+            double tt = (temperature * 2) - 1.0; // Ranges from -1.0 to 1.0
+            saturation += (float) (0.25 * tt * surfaceness);
+            contrast += (float) (-0.1 * tt * surfaceness);
+        }
+        if (mc.currentWorld.dimension == Dimension.NETHER) {
+            lastTemperature = temperature;
+            if (temperature < 0.5) {
+                double tt = temperature * 2; // Ranges from 0.0 to 1.0
+                saturation -= (float) (0.5 * (1.0 - tt));
+            }
         }
 
         // Perform season effects
@@ -142,15 +151,19 @@ public class PostProcessingManager
         }
 
         // Perform dimension effects
-        if (mc.currentWorld.getWorldType() == WorldTypes.NETHER_DEFAULT || mc.currentWorld.getWorldType() == WorldTypes.OVERWORLD_HELL)
+        if (mc.currentWorld.dimension == Dimension.NETHER || mc.currentWorld.getWorldType() == WorldTypes.OVERWORLD_HELL)
         {
-            rMod += 1.2f;
-            gMod += 0.3f;
-            saturation += 0.125f;
+            float scale = 1.0f;
+            if (mc.currentWorld.dimension == Dimension.NETHER && temperature < 0.5) {
+                scale = (float) temperature * 2.0f;
+            }
+            rMod += 1.2f * scale;
+            gMod += 0.3f * scale;
+            saturation += 0.125f * scale;
             exposure -= 0.125f;
             contrast -= 0.05f;
             brightness -= 0.05f;
-            heatHaze = 1f;
+            heatHaze = scale;
         }
 
         // Perform heatwave effects
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java
index a38c8bea9..959d7597a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -32,6 +32,7 @@ public class RenderBlocks
         field_22352_G = 1;
         blockAccess = worldSource;
         renderBitMask = 0;
+        forceAO = false;
         this.mc = Minecraft.getMinecraft();
     }
 
@@ -49,6 +50,7 @@ public class RenderBlocks
         uvRotateBottom = 0;
         field_22352_G = 1;
         renderBitMask = 0;
+        forceAO = false;
         this.mc = Minecraft.getMinecraft();
     }
 
@@ -1047,6 +1049,7 @@ public class RenderBlocks
     public int lightmapCoordBottomRight;
     public int lightmapCoordTopRight; 
     public boolean overbright;
+    public boolean forceAO;
     public RenderBlockCache cache = new RenderBlockCache();
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
index 4735ca002..3f8597e1d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -92,7 +92,8 @@ public class TextureManager {
                 addDynamicTexture(new DynamicTextureLavaStill(TextureRegistry.getTexture("minecraft:block/lava_still")));
                 addDynamicTexture(new DynamicTextureLavaFlowing(TextureRegistry.getTexture("minecraft:block/lava_flowing")));
 //                addDynamicTexture(new DynamicTexturePortal(TextureRegistry.getTexture("minecraft:block/portal_nether"),false));
-                addDynamicTexture(new DynamicTextureFire(TextureRegistry.getTexture("minecraft:block/fire")));
+                addDynamicTexture(new DynamicTextureFire(TextureRegistry.getTexture("minecraft:block/fire"), false));
+				addDynamicTexture(new DynamicTextureFire(TextureRegistry.getTexture("minecraft:block/fire_cold"), true));
 
                 String[] fireflycolors = new String[] {"blue", "orange", "green", "red"};
 				for (String color : fireflycolors) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 7908c72c5..bb6ced0e5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -6,6 +6,7 @@ import java.util.List;
 import java.util.Random;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Mob;
@@ -576,7 +577,11 @@ public class WorldRenderer
                 mouseX = (int) mc.controllerInput.cursorX;
                 mouseY = (int) mc.controllerInput.cursorY;
             }
+            mc.currentScreen.setDesiredCursor(CursorShape.ARROW);
             mc.currentScreen.render(mouseX, mouseY, partialTick);
+            if (mc.currentScreen != null && mc.gameWindow.getCursorShape() != mc.currentScreen.getDesiredCursor()) {
+                mc.gameWindow.setCursorShape(mc.currentScreen.getDesiredCursor());
+            }
             if(mc.inputType == InputType.CONTROLLER && mc.currentScreen != null) {
                 mc.currentScreen.drawControllerCursor();
             }
@@ -808,7 +813,7 @@ public class WorldRenderer
             }
             if(Blocks.blocksList[i2].getMaterial() == Material.lava)
             {
-                mc.particleEngine.add(new ParticleSmoke(world, (float)randX + f1, (double)((float)y + 0.1F) - Blocks.blocksList[i2].getBounds().minY, (float)randZ + f2, 0.0D, 0.0D, 0.0D));
+                mc.particleEngine.add(new ParticleSmoke(world, (float)randX + f1, (double)((float)y + 0.1F) - Blocks.blocksList[i2].getBounds().minY, (float)randZ + f2, 0.0D, 0.0D, 0.0D, 1.0f, 0));
                 continue;
             }
             if(random.nextInt(++l) == 0)
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java
new file mode 100644
index 000000000..914bcdba7
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java
@@ -0,0 +1,52 @@
+package net.minecraft.client.render.block.color;
+
+import net.minecraft.client.render.colorizer.Colorizer;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.noise.ImprovedNoise;
+
+import java.util.Random;
+
+public class BlockColorCrystal extends BlockColorCustom{
+
+    public BlockColorCrystal(Colorizer colorizer) {
+        super(colorizer);
+    }
+    protected static ImprovedNoise crystalPerlinNoise = new ImprovedNoise(new Random(0));
+    @Override
+    public int getWorldColor(WorldSource world, int x, int y, int z) {
+
+        int color = 0xc40e26;
+//        float offsetR = (float) (crystalPerlinNoise.getValue(x / 10f, z / 10f)) * 0.5f;
+//
+//        float r = ((color & 0xFF0000) >> 16) / 255F;
+//        float g = ((color & 0x00FF00) >> 8) / 255F;
+//        float b = (color & 0x0000FF) / 255F;
+//
+//        float newR = r + offsetR;
+//        float newG = g + offsetR;
+//        float newB = b + offsetR;
+//
+//        if(newR > 1.0f)
+//            newR = 1.0f;
+//        if(newR < 0.0f)
+//            newR = 0.0f;
+//
+//        if(newG > 1.0f)
+//            newG = 1.0f;
+//        if(newG < 0.0f)
+//            newG = 0.0f;
+//
+//        if(newB > 1.0f)
+//            newB = 1.0f;
+//        if(newB < 0.0f)
+//            newB = 0.0f;
+//
+//        int finalR = ((int) (newR * 255) & 0xFF) << 16;
+//        int finalG = ((int) (newG * 255) & 0xFF) << 8;
+//        int finalB = ((int) (newB * 255) & 0xFF);
+//
+//        color = finalR | finalG | finalB;
+
+        return color;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
index 40deaa376..5cda20536 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
@@ -40,6 +40,9 @@ public final class BlockColorDispatcher
         addDispatch(Blocks.WIRE_REDSTONE, new BlockColorWireRedstone());
         addDispatch(Blocks.TALLGRASS, new BlockColorCustom(Colorizers.grass));
         addDispatch(Blocks.TALLGRASS_FERN, new BlockColorCustom(Colorizers.grass));
+        addDispatch(Blocks.CRYSTAL, new BlockColorCrystal(Colorizers.crystal));
+        addDispatch(Blocks.CRYSTAL_STALK, new BlockColorCrystal(Colorizers.crystal));
+        addDispatch(Blocks.NETHERRACK_CRYSTALLINE, new BlockColorCrystal(Colorizers.crystal));
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
index 03c18b0ff..283fbcc7a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
@@ -79,6 +79,7 @@ public abstract class BlockModel<T extends BlockLogic>
         renderBlocks.uvRotateBottom = 0;
         renderBlocks.field_22352_G = 1;
         renderBlocks.renderBitMask = 0;
+        renderBlocks.forceAO = false;
     }
     public void setRenderSide(Side side, boolean shouldRender){
         if (!shouldRender){
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCobbledNetherrack.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCobbledNetherrack.java
new file mode 100644
index 000000000..3ccfcec23
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCobbledNetherrack.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+
+public class BlockModelCobbledNetherrack<T extends BlockLogic> extends BlockModelStandard<T> {
+    private IconCoordinate ashSide = TextureRegistry.getTexture("minecraft:block/cobbled_netherrack/ashen_side");
+    public BlockModelCobbledNetherrack(Block<T> block) {
+        super(block);
+    }
+
+    @Override
+    public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
+        Material material = blockAccess.getBlockMaterial(x, y + 1, z);
+        if ((material == Material.topAsh || material == Material.ash) && (side.getAxis() != Axis.Y)) {
+            return ashSide;
+        } else return super.getBlockTexture(blockAccess, x, y, z, side);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystal.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystal.java
new file mode 100644
index 000000000..8a337f278
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystal.java
@@ -0,0 +1,19 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+
+public class BlockModelCrystal<T extends BlockLogic> extends BlockModelTransparent<T>{
+    public BlockModelCrystal(Block<T> block, boolean renderInside) {
+        super(block, renderInside);
+    }
+
+    @Override
+    public boolean render(Tessellator tessellator, int x, int y, int z) {
+        renderBlocks.forceAO = true;
+        boolean flag = super.render(tessellator, x, y, z);
+        renderBlocks.forceAO = false;
+        return flag;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java
new file mode 100644
index 000000000..ef7308b5d
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java
@@ -0,0 +1,74 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.RenderBlocks;
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.opengl.GL11;
+
+public class BlockModelCrystallineNetherrack<T extends BlockLogic> extends BlockModelStandard<T> {
+    protected IconCoordinate overlay;
+    public BlockModelCrystallineNetherrack(Block<T> block) {
+        super(block);
+        overlay = TextureRegistry.getTexture("minecraft:block/nether_crystal/overlay");
+    }
+
+    @Override
+    public boolean render(Tessellator tessellator, int x, int y, int z) {
+        AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
+        renderStandardBlock(tessellator, bounds, x, y, z, 1.0f, 1.0f, 1.0f);
+        renderBlocks.overrideBlockTexture = overlay;
+        renderStandardBlock(tessellator, bounds, x, y, z);
+        renderBlocks.overrideBlockTexture = null;
+        return true;
+    }
+    @Override
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        renderBlocks.useInventoryTint = false;
+        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+        renderBlocks.useInventoryTint = true;
+        GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
+
+        int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
+        float r = (float)(color >> 16 & 0xff) / 255F;
+        float g = (float)(color >> 8 & 0xff) / 255F;
+        float b = (float)(color & 0xff) / 255F;
+        GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
+
+        AABB bounds = block.getBounds();
+        IconCoordinate coord = overlay;
+
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(0.0F, -1F, 0.0F);
+        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
+        tessellator.draw();
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(0.0F, 1.0F, 0.0F);
+        renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
+        tessellator.draw();
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(0.0F, 0.0F, -1F);
+        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
+        tessellator.draw();
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(0.0F, 0.0F, 1.0F);
+        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
+        tessellator.draw();
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(-1F, 0.0F, 0.0F);
+        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
+        tessellator.draw();
+        tessellator.startDrawingQuads();
+        tessellator.setNormal(1.0F, 0.0F, 0.0F);
+        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
+        tessellator.draw();
+        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+    }
+}
\ No newline at end of file
